/*
 * This file is part of osso-teema-testapp
 *
 * Copyright (C) 2005 Nokia Corporation.
 *
 * Contact: Luc Pionchon <luc.pionchon@nokia.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */
#include "interface.h"
#include "callbacks.h"

//Creates the main window
void main_window()
{
        window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
        gtk_container_set_border_width(GTK_WINDOW(window), 10);
	
        frame=gtk_frame_new(" ");
        gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_OUT);
        gtk_frame_set_label_align(GTK_FRAME(frame), 0.5, 0.5);
	gtk_container_add(GTK_CONTAINER(window), frame);

	hbox=gtk_hbox_new(FALSE, 0);
	vbox=gtk_vbox_new(FALSE, 0);
	Bexit=gtk_button_new_with_label("Exit");
	gtk_widget_set_usize(Bexit, 150, 40);

	/*-------------------------Packing-----------------------------------------------------------*/
	gtk_box_pack_end(GTK_BOX(hbox), Bexit, FALSE, 0, 0);
	gtk_box_pack_end(GTK_BOX(vbox), hbox, FALSE, 0, 0);
	gtk_container_add(GTK_CONTAINER(frame), vbox);

	gtk_widget_set_events(window, GDK_BUTTON_PRESS_MASK);

	/*-------------------------Signal Handlers---------------------------------------------------*/
	gtk_signal_connect(GTK_OBJECT(window), "button_press_event", GTK_SIGNAL_FUNC(on_click), NULL);
	gtk_signal_connect(GTK_OBJECT(Bexit), "clicked", gtk_main_quit, NULL);
	gtk_widget_show_all(window);
}


