/*
 * This file is part of osso-teema-testapp
 *
 * Copyright (C) 2005 Nokia Corporation.
 *
 * Contact: Luc Pionchon <luc.pionchon@nokia.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */
#include "interface.h"
#include "callbacks.h"

//Creates the main window
void main_window()
{
         window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
         gtk_container_set_border_width(GTK_WINDOW(window), 10);

	 hbox1=gtk_hbox_new(FALSE, 0);
	 hbox2=gtk_hbox_new(FALSE, 0);
	 hbox3=gtk_hbox_new(FALSE, 0);
	 hbox4=gtk_hbox_new(FALSE, 0);

	 vbox1=gtk_vbox_new(FALSE, 40);
	 
	 frame=gtk_frame_new(" ");
	 gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_OUT);
	 gtk_frame_set_label_align(GTK_FRAME(frame), 0.5, 0.5);
	 gtk_container_add(GTK_CONTAINER(window), frame);
				                                                                                                       
	 Blaunch=gtk_button_new_with_label("Launch Information Banner");
//         align=gtk_alignment_new(0.0, 0.5, 0, 0);
         gtk_widget_set_usize(GTK_WIDGET(Blaunch), 300, 40);
//       gtk_container_add(GTK_CONTAINER(align), Blaunch);
         gtk_box_pack_start(GTK_BOX(hbox1), Blaunch, FALSE, 0, 0);
	 gtk_widget_show(Blaunch);

	 Blaunch3=gtk_button_new_with_label("Launch Information Banner with iconstock");
//       align=gtk_alignment_new(0.0, 0.5, 0, 0);
	 gtk_widget_set_usize(GTK_WIDGET(Blaunch3), 450, 40);
//	 gtk_container_add(GTK_CONTAINER(align), Blaunch3);
	 gtk_box_pack_end(GTK_BOX(hbox1), Blaunch3, FALSE, 0, 0);
	 gtk_widget_show(Blaunch3);
						      

	 Blaunch2=gtk_button_new_with_label("Launch Confirmation Banner");
//         align=gtk_alignment_new(0.0, 0.5, 0, 0);
         gtk_widget_set_usize(GTK_WIDGET(Blaunch2), 300, 40);
//         gtk_container_add(GTK_CONTAINER(align), Blaunch2);
         gtk_box_pack_start(GTK_BOX(hbox2), Blaunch2, FALSE, 0, 0);
         gtk_widget_show(Blaunch2);

	 Blaunch4=gtk_button_new_with_label("Launch Banner with Animation");
	 gtk_widget_set_usize(GTK_WIDGET(Blaunch4), 450, 40);
	 gtk_box_pack_end(GTK_BOX(hbox2), Blaunch4, FALSE, 0, 0);
	 gtk_widget_show(Blaunch2);

	 Bdisable=gtk_button_new_with_label("Disable wrapping for infoprint");
	 gtk_widget_set_usize(GTK_WIDGET(Bdisable), 300, 40);
	 gtk_box_pack_start(GTK_BOX(hbox4), Bdisable, FALSE, 0, 0);


	 Bclose=gtk_button_new_with_label("Close Banner");
	 gtk_widget_set_usize(GTK_WIDGET(Bclose), 200, 40);
	 gtk_widget_set_sensitive(GTK_WIDGET(Bclose), FALSE);
	 gtk_box_pack_end(GTK_BOX(hbox4), Bclose, FALSE, 0, 0);


	 
	 
	 Bexit=gtk_button_new_with_label("Exit");
         align=gtk_alignment_new(0.0, 0.5, 0, 0);
         gtk_widget_set_usize(GTK_WIDGET(Bexit), 550, 40);
         gtk_container_add(GTK_CONTAINER(align), Bexit);
         gtk_box_pack_start(GTK_BOX(hbox3), align, TRUE, 0, 0);
         gtk_widget_show(Bexit);


	 gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, 0, 0);
	 gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, 0, 0);
	 gtk_box_pack_start(GTK_BOX(vbox1), hbox4, FALSE, 0, 0);
	 gtk_box_pack_start(GTK_BOX(vbox1), hbox3, FALSE, 0, 0);
	 gtk_container_add(GTK_CONTAINER(frame), vbox1);

	 /*---------------------------------Signal Handlers----------------------------*/
	 gtk_signal_connect(GTK_OBJECT(Blaunch), "clicked", GTK_SIGNAL_FUNC(on_launch), window);
	 gtk_signal_connect(GTK_OBJECT(Blaunch2), "clicked", GTK_SIGNAL_FUNC(on_launch2), window);
	 gtk_signal_connect(GTK_OBJECT(Bexit), "clicked", GTK_SIGNAL_FUNC(on_exit), NULL);
	 gtk_signal_connect(GTK_OBJECT(Blaunch3), "clicked", GTK_SIGNAL_FUNC(on_launch3), window);
	 gtk_signal_connect(GTK_OBJECT(Blaunch4), "clicked", GTK_SIGNAL_FUNC(on_launch4), window);
	 gtk_signal_connect(GTK_OBJECT(Bclose), "clicked", GTK_SIGNAL_FUNC(on_close), window);
	 gtk_signal_connect(GTK_OBJECT(Bdisable), "clicked", GTK_SIGNAL_FUNC(on_disable), window);
	 
	 gtk_widget_show_all(window);
}

