/*
 * This file is part of osso-teema-testapp
 *
 * Copyright (C) 2005 Nokia Corporation.
 *
 * Contact: Luc Pionchon <luc.pionchon@nokia.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */
#include "callbacks.h"
#include "interface.h"

//Creates the main window
void main_window()
{
        window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
        gtk_container_set_border_width(GTK_CONTAINER(window), 30);
	gtk_window_set_title(GTK_WINDOW(window), "GtkLabel");

	hbox=gtk_hbox_new(FALSE, 0);
	hbox1=gtk_hbox_new(FALSE, 0);
	hbox11=gtk_hbox_new(FALSE, 0);
	hbox2=gtk_hbox_new(FALSE, 0);
	vbox=gtk_vbox_new(FALSE, 50);

	frame=gtk_frame_new(" ");
        gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_OUT);
        gtk_frame_set_label_align(GTK_FRAME(frame), 0.5, 0.5);
	gtk_container_add(GTK_CONTAINER(window), frame);

	Label=gtk_label_new("Target Label");
	gtk_box_pack_start(GTK_BOX(hbox), Label, TRUE, 0, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, 0, 0);

	Lm=gtk_label_new_with_mnemonic("Mnem_onic label:");
	gtk_box_pack_start(GTK_BOX(hbox11), Lm, TRUE, 0, 0);

	Em=gtk_entry_new();
	gtk_label_set_mnemonic_widget(GTK_LABEL(Lm), Em);
	gtk_box_pack_start(GTK_BOX(hbox11), Em, TRUE, 0, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox11, FALSE, 0, 0);
	

	Bprop=gtk_button_new_with_label("Properties");
        align=gtk_alignment_new(0.5, 0.5, 0, 0);
        gtk_widget_set_usize(GTK_WIDGET(Bprop), 250, 40);
        gtk_container_add(GTK_CONTAINER(align), Bprop);
        gtk_box_pack_start(GTK_BOX(hbox1), align, TRUE, 0, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox1, FALSE, 0, 0);

	Bexit=gtk_button_new_with_label("Exit");
	gtk_widget_set_usize(GTK_WIDGET(Bexit), 150, 40);
	gtk_box_pack_end(GTK_BOX(hbox2), Bexit, FALSE, 0, 0);
	gtk_box_pack_end(GTK_BOX(vbox), hbox2, TRUE, 0, 0);

	/*------------------------Signal handlers--------------------------------------*/
	gtk_signal_connect(GTK_OBJECT(Bprop), "clicked", GTK_SIGNAL_FUNC(on_prop), NULL);
	gtk_signal_connect(GTK_OBJECT(Bexit), "clicked", gtk_main_quit, NULL);
	
					    
	gtk_container_add(GTK_CONTAINER(frame), vbox);
	gtk_widget_show_all(window);
}
				   
			
