/*
 * This file is part of osso-teema-testapp
 *
 * Copyright (C) 2005 Nokia Corporation.
 *
 * Contact: Luc Pionchon <luc.pionchon@nokia.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */
#include "interface.h"
#include "callbacks.h"

//Creates the main window
void main_window()
{
         window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
         gtk_container_set_border_width(GTK_WINDOW(window), 10);

	 hbox1=gtk_hbox_new(FALSE,0);
	 vbox1=gtk_vbox_new(FALSE, 30);
	 hbox2=gtk_hbox_new(FALSE, 0);
	 hbox3=gtk_hbox_new(FALSE, 0);
	 hbox4=gtk_hbox_new(FALSE, 0);
	 hbox5=gtk_hbox_new(FALSE, 0);
	  
	 
	 frame=gtk_frame_new(" ");
         gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_OUT);
         gtk_frame_set_label_align(GTK_FRAME(frame), 0.5, 0.5);
         gtk_container_add(GTK_CONTAINER(window), frame);

	 option_menu=gtk_option_menu_new();
         gtk_widget_set_usize(GTK_WIDGET(option_menu), 550, 50);
	 align=gtk_alignment_new(0.5, 0.5, 0, 0);

         menu=gtk_menu_new();
         menu_item=gtk_menu_item_new_with_label("GTK_FILE_CHOOSER_ACTION_OPEN");
         gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_item);

	 menu_item=gtk_menu_item_new_with_label("GTK_FILE_CHOOSER_ACTION_SAVE");
         gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_item);

	 menu_item=gtk_menu_item_new_with_label("GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER");
         gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_item);

	 menu_item=gtk_menu_item_new_with_label("GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER");
         gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_item);

	 gtk_option_menu_set_menu(GTK_OPTION_MENU(option_menu),menu);
	 gtk_container_add(GTK_CONTAINER(align), option_menu);
         gtk_widget_show(option_menu);
         gtk_box_pack_start(GTK_BOX(hbox4), align, TRUE, FALSE, 0);
	 gtk_box_pack_start(GTK_BOX(vbox1), hbox4, FALSE, 0, 0);

	 check=gtk_check_button_new_with_label("Multiple Selection");
	 gtk_box_pack_start(GTK_BOX(hbox5), check, FALSE, 0, 0);

	 Blaunch=gtk_button_new_with_label("Launch File-chooser-dialog");
         align=gtk_alignment_new(0.5, 0.5, 0, 0);
         gtk_widget_set_usize(GTK_WIDGET(Blaunch), 350, 40);
	 gtk_container_add(GTK_CONTAINER(align), Blaunch);
	 gtk_box_pack_start(GTK_BOX(hbox1), align, TRUE, 0, 0);
	 gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, 0, 0);
	 gtk_widget_show(Blaunch);

	 hsep=gtk_hseparator_new();
	 gtk_box_pack_start(GTK_BOX(vbox1), hsep, FALSE, 0, 0);
							       
		  
	 gtk_box_pack_start(GTK_BOX(vbox1), hbox5, FALSE, 0, 0);
	 Blaunch1=gtk_button_new_with_label("Launch File-chooser dialog with properties");
         align=gtk_alignment_new(0.5, 0.5, 0, 0);
         gtk_widget_set_usize(GTK_WIDGET(Blaunch1), 600, 40);
         gtk_container_add(GTK_CONTAINER(align), Blaunch1);
         gtk_box_pack_start(GTK_BOX(hbox3), align, TRUE, 0, 0);
         gtk_box_pack_start(GTK_BOX(vbox1), hbox3, FALSE, 0, 0);
	 gtk_widget_show(Blaunch1);
						      

	 Bexit=gtk_button_new_with_label("Exit");
	 gtk_widget_set_usize(GTK_WIDGET(Bexit), 150, 40);
	 gtk_box_pack_end(GTK_BOX(hbox2), Bexit, FALSE, 0, 0);
	 gtk_box_pack_end(GTK_BOX(vbox1), hbox2, FALSE, 0, 0);
	 gtk_container_add(GTK_CONTAINER(frame), vbox1);

	 /*----------------------Signal Handlers-----------------------------*/
	 gtk_signal_connect(GTK_OBJECT(Bexit), "clicked", gtk_main_quit, NULL);
	 gtk_signal_connect(GTK_OBJECT(Blaunch), "clicked", GTK_SIGNAL_FUNC(on_launch), NULL);
	 gtk_signal_connect(GTK_OBJECT(Blaunch1), "clicked", GTK_SIGNAL_FUNC(on_launch1), NULL);
         gtk_widget_show(Blaunch);


	 gtk_widget_show_all(window);
}


