/*
 * This file is part of osso-teema-testapp
 *
 * Copyright (C) 2005 Nokia Corporation.
 *
 * Contact: Luc Pionchon <luc.pionchon@nokia.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */
#include "callbacks.h"
#include "interface.h"


void th_window()
{
	th_win=gtk_window_new(GTK_WINDOW_TOPLEVEL);
        gtk_container_set_border_width(GTK_CONTAINER(th_win), 10);
}
void sec_window()
{
	sec_win=gtk_window_new(GTK_WINDOW_TOPLEVEL);
        gtk_container_set_border_width(GTK_CONTAINER(sec_win), 10);

	hbox1=gtk_hbox_new(FALSE, 0);
	vbox1=gtk_vbox_new(FALSE, 0);

	Bback=gtk_button_new_with_label("Back");
	gtk_box_pack_end(GTK_BOX(hbox1), Bback, FALSE, 0, 0);
	gtk_box_pack_end(GTK_BOX(vbox1), hbox1, FALSE, 0, 0);
	gtk_signal_connect(GTK_OBJECT(Bback), "clicked", GTK_SIGNAL_FUNC(on_back), NULL);

	gtk_container_add(GTK_CONTAINER(sec_win), vbox1);
	
}

void main_window()
{
	sec_window();
	th_window();
	window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
        gtk_container_set_border_width(GTK_CONTAINER(window), 10);
	gtk_window_set_title(GTK_WINDOW(window), "Hildon FindDialog");


	hbox=gtk_hbox_new(FALSE, 0);
	hbox2=gtk_hbox_new(FALSE, 0);
	hbox3=gtk_hbox_new(FALSE, 0);
	hbox4=gtk_hbox_new(FALSE, 0);
	hbox5=gtk_hbox_new(FALSE, 0);
	hbox6=gtk_hbox_new(FALSE, 0);
	vbox=gtk_vbox_new(FALSE, 15);
	vbox2=gtk_vbox_new(FALSE, 0);

        frame1=gtk_frame_new(" ");
        gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_ETCHED_OUT);
        gtk_frame_set_label_align(GTK_FRAME(frame1), 0.5, 0.5);

	Blaunch=gtk_button_new_with_label("Launch Hildon FindDialog");
	gtk_widget_set_usize(Blaunch, 300, 40);
	gtk_box_pack_start(GTK_BOX(hbox), Blaunch, FALSE, 0, 0);
	gtk_signal_connect(GTK_OBJECT(Blaunch), "clicked", GTK_SIGNAL_FUNC(on_launch), window);

	

	Blaunch_options=gtk_button_new_with_label("Launch Hildon FindDialog with Options");
        gtk_widget_set_usize(Blaunch_options, 450, 40);
        gtk_box_pack_end(GTK_BOX(hbox), Blaunch_options, FALSE, 0, 0);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, 0, 0);
        gtk_signal_connect(GTK_OBJECT(Blaunch_options), "clicked", GTK_SIGNAL_FUNC(on_launch_options), window);

	GtkWidget *hsep=gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(vbox), hsep, FALSE, 0, 0);

	Blaunch_replace=gtk_button_new_with_label("Launch Hildon Find & Replace Dialog");
	gtk_widget_set_usize(Blaunch_replace, 550, 40);
	gtk_box_pack_start(GTK_BOX(hbox4), Blaunch_replace, FALSE, 0, 120);
	gtk_box_pack_start(GTK_BOX(vbox), hbox4, FALSE, 0, 0);
	gtk_signal_connect(GTK_OBJECT(Blaunch_replace), "clicked", GTK_SIGNAL_FUNC(on_launch_replace), window);

	hsep=gtk_hseparator_new();
        gtk_box_pack_start(GTK_BOX(vbox), hsep, FALSE, 0, 0);

	Rread=gtk_radio_button_new_with_label(NULL, "Read Only Mode");
	gtk_box_pack_start(GTK_BOX(hbox6), Rread, FALSE, 0, 0);

	Rnormal=gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(Rread), "Normal Mode");
	gtk_box_pack_start(GTK_BOX(hbox6), Rnormal, FALSE, 0, 0);

	Rimmut=gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(Rnormal), "Immutable Mode");
	gtk_box_pack_start(GTK_BOX(hbox6), Rimmut, FALSE, 0, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox6, FALSE, 0, 0);

	Blaunch_replace_options=gtk_button_new_with_label("Launch Hildon Find & Replace Dialog with Options");
	gtk_widget_set_usize(Blaunch_replace_options, 550, 40);
        gtk_box_pack_start(GTK_BOX(hbox5), Blaunch_replace_options, FALSE, 0, 120);
	gtk_box_pack_start(GTK_BOX(vbox), hbox5, FALSE, 0, 0);
	gtk_signal_connect(GTK_OBJECT(Blaunch_replace_options), "clicked", GTK_SIGNAL_FUNC(on_launch_replace_options), NULL);

	hsep=gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(vbox), hsep, FALSE, 0, 0);
	
	Blabel=gtk_label_new("Status:  ");
	gtk_widget_set_usize(Blabel, 300, 300);
	gtk_box_pack_start(GTK_BOX(vbox), Blabel, FALSE, 0, 0);

	Bexit=gtk_button_new_with_label("Exit");
	gtk_widget_set_usize(Bexit, 200, 40);
	gtk_box_pack_end(GTK_BOX(hbox2), Bexit, FALSE, 0, 0);
	gtk_box_pack_end(GTK_BOX(vbox), hbox2, FALSE, 0, 0);
	gtk_signal_connect(GTK_OBJECT(Bexit), "clicked", GTK_SIGNAL_FUNC(on_exit), NULL);
	
	gtk_container_add(GTK_CONTAINER(frame1), vbox);
	gtk_container_add(GTK_CONTAINER(window), frame1);
	gtk_widget_show_all(window);
}
				
