/*
 * This file is part of osso-teema-testapp
 *
 * Copyright (C) 2005 Nokia Corporation.
 *
 * Contact: Luc Pionchon <luc.pionchon@nokia.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */
#include "interface.h"
#include "callbacks.h"
#include "hildon-widgets/hildon-set-password-dialog.h"
#include "hildon-widgets/hildon-get-password-dialog.h"  

//Creates the main window
void create_main_window()
{
	window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	
	/*--------Creates second window---------*/
		
	display();
        gtk_container_set_border_width(GTK_CONTAINER(window), 10);
	hbox1=gtk_hbox_new(FALSE, 0);
	hbox2=gtk_hbox_new(FALSE, 10);
	hbox3=gtk_hbox_new(FALSE, 10);
	hbox4=gtk_hbox_new(FALSE, 10);
	hbox5=gtk_hbox_new(FALSE, 0);
	hbox6=gtk_hbox_new(FALSE, 0); 
	vbox1=gtk_vbox_new(FALSE, 10);
	vbox2=gtk_vbox_new(FALSE, 40);
	vbox3=gtk_vbox_new(FALSE, 10);
	align=gtk_alignment_new(0.5, 0.5, 0, 0);
	frame1=gtk_frame_new(" ");
	gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_ETCHED_OUT);
	gtk_frame_set_label_align(GTK_FRAME(frame1), 0.5, 0.5);
	gtk_box_pack_start(GTK_BOX(hbox1), frame1, FALSE, 0, 0);

	Bset=gtk_button_new_with_label("Launch Set Password Dialog");
	gtk_widget_set_usize(GTK_WIDGET(Bset), 360, 40 );
	gtk_box_pack_start(GTK_BOX(hbox2), Bset, FALSE, 0, 0 );

	Bset_change=gtk_button_new_with_label("Launch Change Password Dialog");
        gtk_widget_set_usize(GTK_WIDGET(Bset_change), 400, 40 );
        gtk_box_pack_start(GTK_BOX(hbox2), Bset_change, FALSE, 0, 0 );
        gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, 0, 0 );

	Bget=gtk_button_new_with_label("Launch Get Password Dialog");
	gtk_widget_set_usize(GTK_WIDGET(Bget), 360,40 );
	gtk_box_pack_start(GTK_BOX(hbox3), Bget, FALSE, 0, 0 );


	 Lget_pwd1=gtk_label_new("Password: ");
         gtk_box_pack_start(GTK_BOX(hbox4), Lget_pwd1, FALSE, 0 , 0 );


	Lget_pwd=gtk_label_new(" ");
	gtk_box_pack_start(GTK_BOX(hbox4), Lget_pwd, FALSE, 0 , 0 );

	Bget_old=gtk_button_new_with_label("Launch Old Password Dialog");
        gtk_widget_set_usize(GTK_WIDGET(Bget_old), 400, 40 );
        gtk_box_pack_start(GTK_BOX(hbox3), Bget_old, FALSE, 0 , 0 );
	gtk_box_pack_start(GTK_BOX(vbox2), hbox3, FALSE, 0, 0);

/*	Lpro1=gtk_label_new("Protected: ");
	gtk_box_pack_start(GTK_BOX(hbox6), Lpro1, FALSE, 0 , 0 );
			            
	Lpro2=gtk_label_new(" ");
        gtk_box_pack_start(GTK_BOX(hbox6), Lpro2, FALSE, 0 , 0 );
	gtk_box_pack_start(GTK_BOX(vbox2), hbox6, FALSE, 0, 0);*/


	gtk_box_pack_start(GTK_BOX(vbox2), hbox4, FALSE, 0, 0 );
			
	gtk_box_pack_start(GTK_BOX(vbox3), vbox2, FALSE, 0, 0 );
	 

	Bexit=gtk_button_new_with_label("Exit");
	gtk_widget_set_usize(GTK_WIDGET(Bexit), 250, 40 );
        gtk_box_pack_end(GTK_BOX(hbox5), Bexit, FALSE, 0 , 0 );
	gtk_box_pack_start(GTK_BOX(vbox3), hbox5, FALSE, 0, 0 );
		
	gtk_container_add(GTK_CONTAINER(frame1), vbox3);
	gtk_container_add(GTK_CONTAINER(vbox1), hbox1);
	gtk_container_add(GTK_CONTAINER(window), vbox1);

	/*-------------------------Signal Handlers-------------------------------------------*/
	gtk_signal_connect(GTK_OBJECT(Bset), "clicked" , GTK_SIGNAL_FUNC(on_set), NULL);
	gtk_signal_connect(GTK_OBJECT(Bget), "clicked", GTK_SIGNAL_FUNC(on_get), NULL);
	gtk_signal_connect(GTK_OBJECT(Bset_change), "clicked" , GTK_SIGNAL_FUNC(on_set_change), NULL);
	gtk_signal_connect(GTK_OBJECT(Bexit), "clicked", GTK_SIGNAL_FUNC(on_Exit), NULL);
	gtk_signal_connect(GTK_OBJECT(Bget_old), "clicked", GTK_SIGNAL_FUNC(on_get_old), NULL);

	gtk_widget_show_all(window);


}
			
